package de.bsvrz.datex2.test.factories;
import java.util.Arrays;
import java.util.List;

import de.bsvrz.datex2.test.mockclasses.MockDataModel;
import de.bsvrz.datex2.test.mockclasses.MockDavConnection;
import de.bsvrz.datex2.test.mockclasses.MockPids;
import de.bsvrz.datex2.test.mockclasses.MockSystemObject;
import de.bsvrz.dav.daf.main.config.ConfigurationChangeException;
import de.bsvrz.dav.daf.main.config.ObjectSet;


public class CreateMockMessquerschnitte extends CreateMockObjects {
  public CreateMockMessquerschnitte() {
    super();
  }
  
  public CreateMockMessquerschnitte(MockDataModel dataModel) {
    super(dataModel);
  }
  
  @Override
  public void create() throws ConfigurationChangeException {
    assert(usedDataModel != null);
    
    @SuppressWarnings("unused")
    MockSystemObject mq01 = createMessquerschnitt("pid.mq01", 55432323, 493232454);
    @SuppressWarnings("unused")
    MockSystemObject mq02 = createMessquerschnitt("pid.mq02", 55432323, 493232453);   
  }

  public MockSystemObject createMessquerschnitt(String pid, int locationX, int locationY) {
    return createLocatedObject(pid, MockPids.TYP_MESSQUERSCHNITT, locationX, locationY);
  }

  public MockSystemObject createUmfelddatensensor(String typ, String pid, MockSystemObject ufdms) throws ConfigurationChangeException {
    MockSystemObject ufds = new MockSystemObject(pid, typ);
    ufds.setDataModel(usedDataModel);
    usedDataModel.addObject(usedDataModel.getType(typ), ufds);
    verbindeMessstelleUndSensor(ufdms, ufds);
    return ufds;
  }
  
  public void verbindeMessstelleUndSensor(MockSystemObject ufdms, MockSystemObject ufds) throws ConfigurationChangeException {
    if (ufdms != null) {
      ObjectSet objSet = ufdms.getObjectSet("UmfeldDatenSensoren");
      objSet.add(ufds);
    }
  }

  public void mockSendDataToAll(MockDavConnection davConnection, int number, SendOptions sendOptions) {
    List<String> attributeList = Arrays.asList("QPkw", "QLkw", "QKfz", "VPkw", "VLkw", "VKfz", "ALkw");
    mockSendNumericData(davConnection, MockPids.TYP_MESSQUERSCHNITT, attributeList, "Wert", number, sendOptions);
  }

  @Override
  public void mockSendValidDataToAll(MockDavConnection davConnection) {
    mockSendDataToAll(davConnection, 20, SendOptions.NORMAL);
  }
    
}
