package de.bsvrz.datex2.test.mockclasses;
import java.io.NotActiveException;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import javax.activation.UnsupportedDataTypeException;

import de.bsvrz.kex.datex2.allgemein.PersistenzModul;


public class MockKonfigUndPersistenzModul implements PersistenzModul {
  Map<String,String> localMap = new HashMap<>();
  
  @Override
  public String getContext() {
    return "Test";
  }

  @Override
  public boolean hasData(String key) {
    return localMap.containsKey(key);
  }
  
  public void removeData(String key) {
    localMap.remove(key);
  }

  @Override
  public <T extends Serializable> T getData(String key, Class<T> classx)
      throws UnsupportedDataTypeException, NotActiveException,
      IllegalArgumentException {
    if (classx == Integer.class) {
      return classx.cast(Integer.parseInt(localMap.get(key)));
    }
    return classx.cast(localMap.get(key));
  }

  @Override
  public String getString(String key) {
    return localMap.get(key);
  }

  @Override
  public Integer getInteger(String key) {
    return new Integer(localMap.get(key));
  }

  @Override
  public <T extends Serializable> void putData(String key, T x) {
    localMap.put(key,x.toString());
  }

}
